main()
{

	maps\mp\_load::main();
	maps\mp\vaddhe_b_fx::main();

	game["allies"] = "british";
	game["axis"] = "german";

	game["attackers"] = "allies";
	game["defenders"] = "axis";

	game["british_soldiertype"] = "commando";
	game["british_soldiervariation"] = "normal";
	game["german_soldiertype"] = "fallschirmjagercamo";
	game["german_soldiervariation"] = "normal";

	level.obj["v2manual"] = ("plans du V2");
	game["re_attackers"] = "allies";
	game["re_defenders"] = "axis";

	game["re_attackers_obj_text"] = "Steal the V2 plans";
	game["re_defenders_obj_text"] = "Guard the V2 plans";
	game["re_spectator_obj_text"] = "Allies: Steal the V2 plans\nAxis: Guard the V2 plans";
	game["re_attackers_intro_text"] = "Steal the V2 plans";
	game["re_defenders_intro_text"] = "Guard the V2 plans";
	
	game["ctf_attackers_obj_text"] = "Capture the enemy flag!";
	game["ctf_spectator_obj_text"] = "Voyeur is it?";

	game["dom_allies_obj_text"] = "Capture this V2 facility";
	game["dom_axis_obj_text"] = "Protect this V2 facility";
	game["dom_spectator_obj_text"] = "Capture or protect the V2 facility";
	
	game["hud_allies_victory_image"] = "gfx/hud/hud@mp_victory_vaddhe_b.dds";
	game["hud_axis_victory_image"] = "gfx/hud/hud@mp_victory_vaddhe_g.dds";

	flag1 = getent("flag1","targetname");
	flag1.script_timer = 20;
	flag1.description = " Raketenkontrolle";

 	flag2 = getent("flag2","targetname");
	flag2.script_timer = 10;
	flag2.description = " Abschussplatform";

 	flag3 = getent("flag3","targetname");
	flag3.script_timer = 10;
	flag3.description = " technischer Raum";

 	flag4 = getent("flag4","targetname");
	flag4.script_timer = 10;
	flag4.description = " Beluftung";

	ambientPlay("ambient_mp_chateau");
	SetupDoors();
}

SetupDoors()
{
	doors = getentarray("door","targetname");
	if(isdefined(doors))
	{
		for(i=0;i<doors.size;i++)
		{
			doors[i] thread SetupDoor();
		}
	}
	doorslocked = getentarray("doorlocked", "targetname");
	if(isdefined(doorslocked))
	{
		for(i=0;i<doorslocked.size;i++)
		{
			doorslocked[i] thread PlayDoorLockedSound();
		}
	}
}

PlayDoorLockedSound()
{
	org = spawn("script_model", self getOrigin());
	wait(0.05);
	while(1)
	{
		self waittill("trigger");
		org playsound("vaddhe_b_metal_locked");
	}
}

SetupDoor()
{
	left = getent(self.target, "targetname");
	right = getent(left.target, "targetname");
	left thread TriggerDoor(85, self, right);
	right thread TriggerDoor(-85, self, left);
	if(!isdefined(self.spawnflags))
	{
	    self.spawnflags = 0;
	}
}

TriggerDoor(angle, door, trig)
{
	time = door.time / 1000;
	while(1)
	{
		self waittill("trigger", other);
		// Store initial angles
		curang = self.angles;
		dme = distance(other getOrigin(), self getOrigin());
		dmh = distance(other getOrigin(), trig getOrigin());
		if(dme > dmh) {
			nangle = 0 - angle;
		} else {
			nangle = angle;
		}
		trig triggerOff();

		// Do the rotation in 2 steps
		// During the first step, hold use button to slam the door
		angle8 = nangle / 8;
		time8 = time / 8;

		door playsound("vaddhe_b_metal_open");

		door rotateto((0, angle8, 0), time8, time8, 0);
		door waittill("rotatedone");
		if(other useButtonPressed())
		{
		    // Slam sound
			door playsound("vaddhe_b_kick");
			door rotateto((0, nangle, 0), time8, 0, 0);
		}
		else
		{
			door rotateto((0, nangle, 0), time - time8, 0, time / 2);
			door waittill("rotatedone");
		}

		// Wait for someone to close the door
		while(1)
		{
    		door waitdoorclose(self, 0);
    
    		door playsound("vaddhe_b_metal_closemove");
    		door rotateto((0, 0, 0), time, time / 2, time / 2);
    		// Magic thread to deal with blocked doors :-D
    		blocked = door checkblocked(time, curang, nangle);
    		if(!blocked) {
    			door playsound("vaddhe_b_metal_closestop");
    			trig triggerOn();
    			break;
    		}
		}
	}
}

// Check if door closed in time, if not it's blocked, so reopen it
checkblocked(time, curang, nangle)
{
	wait(time + 0.1);
    ang = self.angles;
    if(ang[0] != curang[0] || ang[1] != curang[1] || ang[2] != curang[2]) {
        // Reopen the door
        self notsolid();
    	self playsound("vaddhe_b_metal_open");
        self rotateto((0, nangle, 0), time/4, time/8, time/8);
        wait(time/4);
        self solid();
        return 1;
    } else {
    	return 0;
    }
}

waitdoorclose(trig, time)
{
	if(time == 0) {
		trig waittill("trigger", other);
	} else {
        if(self.spawnflags == 0)
        {
            // Auto closing the door
            self.active = 0;
            self thread waitdoortrigger(trig);
        	for(i = 0; i < 10; i++) {
        	    if(self.active == 0) {
        		    wait(time / 10);
        	    } else {
        	    	return;
        	    }
         	}
         	// Kill the trigger thread
            trig notify("trigger");
         } else {
    		// Toggle door
            trig waittill("trigger");
         }
     }
}

waitdoortrigger(trig)
{
	trig waittill("trigger");
	self.active = 1;
}

triggerOff()
{
	if (!isdefined (self.realOrigin))
		self.realOrigin = self.origin;

	if (self.origin == self.realorigin)
		self.origin += (0, 0, -10000);
}

triggerOn()
{
	if (isDefined (self.realOrigin) )
		self.origin = self.realOrigin;
}

